/*
 * ips_audio_pulse_PulseMixerProvider.h
 *
 *  Created on: 10.07.2015
 *      Author: klausj
 */

#ifndef CSRC_IPS_AUDIO_PULSE_PULSEMIXERPROVIDER_H_
#define CSRC_IPS_AUDIO_PULSE_PULSEMIXERPROVIDER_H_

#include <stdio.h>
#include <string.h>
#include <jni.h>
#include <stdlib.h>
#include <pulse/thread-mainloop.h>
#include <pulse/mainloop.h>
#include <pulse/proplist.h>
#include <pulse/context.h>
#include <pulse/introspect.h>

//#define DEBUG

struct pulseMixerProviderNS{
	JavaVM * javaVM;  // JVM reference cache
	JNIEnv *env;      // JNIEnv cache
	jclass jClassRef;  // PulseMixerProvider class ref cache
	jweak javaObjRef;   // PulseMixerprovider instance ref cache
	jweak exceptionClassRef; // Exception class ref cache
	pa_context* paCtx;    // PA context
	pa_threaded_mainloop* paMainloop; // PA main loop
};

typedef struct pulseMixerProviderNS PulseMixerProvider;


#ifdef __cplusplus
extern "C" {
#endif
JNIEXPORT jobject JNICALL Java_ips_audio_pulse_PulseMixerProvider_init(JNIEnv *, jobject,jstring,jstring);
JNIEXPORT void JNICALL Java_ips_audio_pulse_PulseMixerProvider_mainLoop(JNIEnv *, jobject,jobject);
JNIEXPORT void JNICALL Java_ips_audio_pulse_PulseMixerProvider_connect(JNIEnv *, jobject,jobject);
JNIEXPORT void JNICALL Java_ips_audio_pulse_PulseMixerProvider_serverInfo(JNIEnv *, jobject,jobject);
JNIEXPORT void JNICALL Java_ips_audio_pulse_PulseMixerProvider_enumerateCards(JNIEnv *, jobject,jobject);
JNIEXPORT void JNICALL Java_ips_audio_pulse_PulseMixerProvider_mainLoopQuit(JNIEnv *, jobject,jobject);
JNIEXPORT void JNICALL Java_ips_audio_pulse_PulseMixerProvider_disconnect(JNIEnv *, jobject,jobject);
JNIEXPORT void JNICALL Java_ips_audio_pulse_PulseMixerProvider_release(JNIEnv *, jobject,jobject);
#ifdef __cplusplus
}
#endif

void context_state_callback(pa_context *context, void *userdata);
void server_info_cb(pa_context *c, const pa_server_info *i, void *userdata);
void card_info_list_cb(pa_context *c, const pa_card_info *i, int eol, void *userdata);
void source_info_list_cb(pa_context *c, const pa_source_info *i, int eol, void *userdata);
void sink_info_list_cb(pa_context *c, const pa_sink_info *i, int eol, void *userdata);
#endif /* CSRC_IPS_AUDIO_PULSE_PULSEMIXERPROVIDER_H_ */
