

#ifndef CSRC_IPS_AUDIO_PULSE_PULSESOURCEDATALINE_H_
#define CSRC_IPS_AUDIO_PULSE_PULSESOURCEDATALINE_H_

#include <stdio.h>
#include <string.h>
#include <jni.h>
#include <stdlib.h>
#include <pulse/error.h>
#include <pulse/thread-mainloop.h>
#include <pulse/mainloop.h>
#include <pulse/context.h>
#include <pulse/introspect.h>
#include <pulse/stream.h>
#include <pulse/sample.h>


struct pulseSourceDataLineNS{
	JavaVM * javaVM;
	JNIEnv *env;
	jclass jClassRef;
	jweak javaObjRef;
	jweak exceptionClassRef;
	pa_context* paCtx;
	pa_threaded_mainloop* m;
	pa_stream* paStream;
	void* nativeBuf;
	jint nativeBufLen;
};

typedef struct pulseSourceDataLineNS PulseSourceDataLine;

#ifdef __cplusplus
extern "C" {
#endif
JNIEXPORT jobject JNICALL Java_ips_audio_pulse_PulseSourceDataLine_init(JNIEnv *, jobject,jobject);
JNIEXPORT void JNICALL Java_ips_audio_pulse_PulseSourceDataLine_open(JNIEnv *, jobject,jobject,jstring,jint, jint,jint, jint, jboolean);
JNIEXPORT jint JNICALL Java_ips_audio_pulse_PulseSourceDataLine_available(JNIEnv *, jobject,jobject);
JNIEXPORT void JNICALL Java_ips_audio_pulse_PulseSourceDataLine_write(JNIEnv *, jobject,jobject,jbyteArray,jint,jint);
JNIEXPORT jlong JNICALL Java_ips_audio_pulse_PulseSourceDataLine_bytePosition(JNIEnv *, jobject,jobject);
JNIEXPORT jlong JNICALL Java_ips_audio_pulse_PulseSourceDataLine_usecPosition(JNIEnv *, jobject,jobject);
JNIEXPORT void JNICALL Java_ips_audio_pulse_PulseSourceDataLine_trigger(JNIEnv *, jobject,jobject);
JNIEXPORT void JNICALL Java_ips_audio_pulse_PulseSourceDataLine_flushBegin(JNIEnv *, jobject,jobject);
JNIEXPORT void JNICALL Java_ips_audio_pulse_PulseSourceDataLine_drainBegin(JNIEnv *, jobject,jobject);
JNIEXPORT void JNICALL Java_ips_audio_pulse_PulseSourceDataLine_cork(JNIEnv *, jobject,jobject,jboolean);
JNIEXPORT void JNICALL Java_ips_audio_pulse_PulseSourceDataLine_close(JNIEnv *, jobject,jobject);
JNIEXPORT void JNICALL Java_ips_audio_pulse_PulseSourceDataLine_release(JNIEnv *, jobject,jobject);

#ifdef __cplusplus
}
#endif

void play_stream_cb(pa_stream *, void *);
void drain_cb(pa_stream *, int, void *);
void flush_cb(pa_stream *, int, void *);
void cork_cb(pa_stream *, int, void *);

#endif /* CSRC_IPS_AUDIO_PULSE_PULSEMIXERPROVIDER_H_ */
